
    'IFS7

    ' Random iteration image reconstruction
    '      see eg BYTE, January 1988
    ' Modified Xmas 2002

    nomainwin

    UpperLeftX    =  10
    UpperLeftY    =  10
    WindowWidth   = 800
    WindowHeight  = 600

    xscale        =  40
    xoffset       = 300
    yscale        = -40
    yoffset       = 460

    shape$( 1)    ="Tree"
    shape$( 2)    ="Square"
    shape$( 3)    ="JF"
    shape$( 4)    ="Fern"
    shape$( 5)    ="Sierpinski"
    shape$( 6)    ="Spiral"
    shape$( 7)    ="Trunk"

    selected$     ="Fern"
    restore [FERN]

    graphicbox #w.g                                5,   5, 580, 560
    button     #w.b1, "Superpose Axes",   [axes],  UR,  80, 320
    button     #w.b2, "Quit",   [quit],            LR,  30,  20
    button     #w.b3, "Merry Xmas LB'ers", [xmas], UR,  60, 360
    textbox    #w.t,                             600,  20, 150,  24
    listbox    #w.l,  shape$(), [selectshape],   600,  60, 150, 200
    'menu       #w,    "Help", "IFS", [IFS]

    loadbmp "star", "star.bmp"

    open "Merry IFS Xmas to all LB'ers" for window as #w
    #w "trapclose [quit]"
    #w.g "down ; backcolor cyan ; goto 0 0 ; boxfilled 580 560"
    #w.l "font trinity_bold 12"
    #w.t "Double click your selection."

    tiles =5                        '(max number of transformations or tilings)
    dim a( tiles)
    dim b( tiles)
    dim c( tiles)
    dim d( tiles)
    dim e( tiles)
    dim f( tiles)
    dim p( tiles)

    #w.g "color darkgreen"

    [main]
    read m
    pt = 0' total probability (should =1)

    for j =1 to m
        read a, b, c,      d, e, f,     pk
        a( j) =a: b( j) =b: c( j) =c: d( j) =d: e( j) =e: f( j) =f: pt =pt +pk: p( j) =pt
    next j

    x = 1
    y = 1
    n = 0

    col$( 0) ="red"
    col$( 1) ="darkgreen"
    col$( 2) ="darkblue"
    col$( 3) ="pink"

    [iterate]
        n       =n +1
        pk      = rnd( 1)
        select case
            case pk <=p( 1)
                k =1
            case pk >p( 1) and pk <=p( 2)
                k =2
            case pk >p( 2) and pk <=p( 3)
                k =3
            case pk >p( 3) and pk <=p( 4)
                k =4
            case pk >p( 4) and pk <=p( 5)
                k =5
            case else
                k =5
        end select
        newx    = a( k) *x + b( k) *y + e( k)
        newy    = c( k) *x + d( k) *y + f( k)
        x       = newx
        y       = newy
        if n >20 then #w.g "set "; str$( int( 0.5 +x *xscale +xoffset)); " "; str$( int( 0.5 +y *yscale +yoffset))
        scan
    goto [iterate]

    wait

    [selectshape]
        print #w.l, "selection? selected$"
        select case selected$
            case "Fern"
                restore [FERN]
            case "Spiral"
                restore [SPIRAL]
            case "JF"
                restore [JF]
            case "Tree"
                restore [TREE]
            case "Sierpinski"
                restore [SIERPINSKI]
            case "Square"
                restore [SQUARE]
            case "Trunk"
                restore [TRUNK]
            'case else
                  'confirm "No valid choice. OK?"; answer$
        end select
        selected$ =""
        #w.g "cls"
    goto [main]

    [IFS]
    #w.g "flush"
    WindowWidth  =500
    WindowHeight =200
    open "About IFS transforms" for text as #x
        t$ ="This program is based on the ideas of self-similarity." +chr$( 10)
        t$ =t$ + "Any point in the (x,y) plane can be moved to any other" +chr$( 10)
        t$ =t$ +"by a transformation involving its old x, old y positions" +chr$( 10)
        t$ =t$ +"& three constants. x(new) =a  x(old) +b y(old) +c and" +chr$( 10)
        t$ =t$ +"y(new) =d x(old) +e y(old) +f. Further notes e-mail me."
        #x t$
        wait
    close #x
    goto [main]

    [axes]
    for jx = -12 to 12
        if jx =0 then
            #w.g "color red"
            #w.g "size 5"
        else
            #w.g "color lightgray"
            #w.g "size 2"
        end if
        xi =int( 0.5 +jx *xscale +xoffset)
        #w.g "line "; str$( xi); " 0 "; str$( xi); " 700"
     next jx
     for jy = -12 to 12
        if jy =0 then
            #w.g "color red"
            #w.g "size 5"
        else
            #w.g "color lightgray"
            #w.g "size 2"
        end if
        yi =int( 0.5 +jy *yscale +yoffset)
        #w.g "line "; " 0 "; str$( yi); " 800 "; str$( yi)
     next jy
    #w.g "color darkgreen"
    #w.g "size 1 ; flush"
    goto [iterate]

    [xmas]
    #w.g "color red backcolor yellow down"
    for xmas =1 to 20
        xxx =int( 0.5 +xscale *( 10 -20 *rnd( 1)) +xoffset)
        yyy =int( 0.5 +yscale *( 25 -25 *rnd( 1)) +yoffset)
        #w.g "drawbmp star ";  str$( xxx); " "; str$( yyy)
    next xmas
    xr =-150 +600 *rnd( 1)
    yr =      500 *rnd( 1)
    fr =   8 + 20 *rnd( 1)
    cr =        4 *rnd( 1)
    #w.g "font courier_new "; str$( int( fr)); " bold"
    #w.g "color "; col$(cr)
    #w.g "up"
    #w.g "goto "; str$( xr); " "; str$( yr)
    #w.g "down"
    #w.g "\Merry Xmas!"
    #w.g "color darkgreen"
    goto [iterate]

    [quit]
    unloadbmp "star"
    close #w

    '_____________________________________________________________________-

        ' In the following data statements, read
        '   first the number of affine transformations.
        ' Each transform equation is linear, as follows,
        '   x_new =ax +by +c; y_new =dx +ey +f
        ' so then read the coefficients a,b,c & d,e,f & probability for each.

    [FERN]
    data 4
    data     0,    0,    0,               0.16,      0,     0,         0.01
    data   0.2,-0.26, 0.23,               0.22,      0,   1.6,         0.07
    data -0.15, 0.28, 0.26,               0.24,      0,  0.44,         0.07
    data  0.85, 0.04,-0.04,               0.85,      0,   1.6,         0.85

    [JF]
    data 5
    data     0,   -1,.1737,             .0825,      1,   .745,         0.35
    data .3185,.0455,-.091,             .7731,  .2364,  .1188,         0.35
    data     0,-.375,.2275,             .0686,   .975,  .3054,         0.15
    data .1096,.0231,-.018,             .3050,  .0684,  .0141,         0.07
    data .4456,.0144,.0187,             .1452,  .1410,  -.014,         0.08

    [TREE]
    data 4
    data     0,    0,    0,               0.5,      0,      0,         0.05
    data   0.1,    0,    0,               0.1,      0,    0.2,         0.15
    data  0.42,-0.42, 0.42,              0.42,      0,    0.2,         0.4
    data  0.42, 0.42,-0.42,              0.42,      0,    0.2,         0.4

    [SQUARE]
    data   4
    data     1,    0,    0,               0.5,      0,      1,         0.25
    data     1,    0,    0,               0.5,      0,    0.5,         0.25
    data   0.5,    0,    0,                 1,    0.5,      0,         0.25
    data   0.5,    0,    0,                 1,      1,      0,         0.25

    [SIERPINSKI]
    data 3
    data   0.5,    0,    0,               0.5,       0,     0,         0.33
    data   0.5,    0,    0,               0.5,       1,     0,         0.33
    data   0.5,    0,    0,               0.5,     0.5,   0.5,         0.34

    [SPIRAL]
    data 2
    data 0.846,-0.308, 0.308,           0.846,        0,    0,         0.9
    data  -0.1,-0.173, 0.173,            -0.1,        1, -1.5,         0.1

    [TRUNK]
    DATA 2
    DATA   0.9,-0.09,   0.09,             0.9,        0,     0,        0.9
    DATA     0,-0.09,    0.9,               0,        1,     1,        0.1

    end

